/*
 * Simulator of microcontrollers (cmdsetcl.h)
 *
 * Copyright (C) 1999,99 Drotos Daniel, Talker Bt.
 * 
 * To contact author send email to drdani@mazsola.iit.uni-miskolc.hu
 *
 */

/* This file is part of microcontroller simulator: ucsim.

UCSIM is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

UCSIM is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with UCSIM; see the file COPYING.  If not, write to the Free
Software Foundation, 59 Temple Place - Suite 330, Boston, MA
02111-1307, USA. */
/*@1@*/

#ifndef CMDSETCL_HEADER
#define CMDSETCL_HEADER

#include "cmdcl.h"


// CONF
class cl_conf_cmd: public cl_cmd
{
public:
  cl_conf_cmd(class cl_sim *asim,
	      char *aname,
	      int  can_rep,
	      char *short_hlp,
	      char *long_hlp):
    cl_cmd(asim, aname, can_rep, short_hlp, long_hlp) {}
  virtual int work(class cl_cmdline *cmdline, class cl_console *con);
};

// STATE
class cl_state_cmd: public cl_cmd
{
public:
  cl_state_cmd(class cl_sim *asim,
	       char *aname,
	       int  can_rep,
	       char *short_hlp,
	       char *long_hlp):
    cl_cmd(asim, aname, can_rep, short_hlp, long_hlp) {}
  virtual int work(class cl_cmdline *cmdline, class cl_console *con);
};

// RUN
class cl_run_cmd: public cl_cmd
{
public:
  cl_run_cmd(class cl_sim *asim,
	     char *aname,
	     int  can_rep,
	     char *short_hlp,
	     char *long_hlp):
    cl_cmd(asim, aname, can_rep, short_hlp, long_hlp) {}
  virtual int work(class cl_cmdline *cmdline, class cl_console *con);
};

// STEP
class cl_step_cmd: public cl_cmd
{
public:
  cl_step_cmd(class cl_sim *asim,
	      char *aname,
	      int  can_rep,
	      char *short_hlp,
	      char *long_hlp):
    cl_cmd(asim, aname, can_rep, short_hlp, long_hlp) {}
  virtual int work(class cl_cmdline *cmdline, class cl_console *con);
};

// RESET
class cl_reset_cmd: public cl_cmd
{
public:
  cl_reset_cmd(class cl_sim *asim,
	       char *aname,
	       int  can_rep,
	       char *short_hlp,
	       char *long_hlp):
    cl_cmd(asim, aname, can_rep, short_hlp, long_hlp) {}
  virtual int work(class cl_cmdline *cmdline, class cl_console *con);
};

// DUMP
class cl_dump_cmd: public cl_cmd
{
public:
  uint start;

public:
  cl_dump_cmd(class cl_sim *asim,
	      char *aname,
	      int  can_rep,
	      char *short_hlp,
	      char *long_hlp):
    cl_cmd(asim, aname, can_rep, short_hlp, long_hlp) { start= 0; }
  virtual int work(class cl_cmdline *cmdline, class cl_console *con);
};

// DI
class cl_di_cmd: public cl_cmd
{
public:
  //uint start;

public:
  cl_di_cmd(class cl_sim *asim,
	    char *aname,
	    int  can_rep,
	    char *short_hlp,
	    char *long_hlp):
    cl_cmd(asim, aname, can_rep, short_hlp, long_hlp) { /*start= 0;*/ }
  virtual int work(class cl_cmdline *cmdline, class cl_console *con);
};

// QUIT
class cl_quit_cmd: public cl_cmd
{
public:
  cl_quit_cmd(class cl_sim *asim,
	      char *aname,
	      int  can_rep,
	      char *short_hlp,
	      char *long_hlp):
    cl_cmd(asim, aname, can_rep, short_hlp, long_hlp) {}
  virtual int work(class cl_cmdline *cmdline, class cl_console *con);
};


#endif

/* End of cmdsetcl.h */
